-- 0:Rest 1:WarmUp 2-:ChangeDancerAnimation
local gamePoint = 0

local fps = 1.0/60
local tmpDelta = 0
local song
local pnTiming = {}
local stopList = {}
local curStop  = {PlayerNumber_P1 = 1, PlayerNumber_P2 = 1}
local lastCheckBeat = -9999

local function update(self, delta)
    tmpDelta = tmpDelta + delta
    if tmpDelta > fps then
        tmpDelta = tmpDelta - fps
        -- 毎フレーム発行
        local pos  = GAMESTATE:GetSongPosition()
        local sec  = pos:GetMusicSeconds()
        local beat = GAMESTATE:GetSongBeat()
        local isStop = pos:GetFreeze() or pos:GetDelay()
        local isPnStop = {PlayerNumber_P1 = false, PlayerNumber_P2 = false}
        for p,pn in pairs(PlayerNumber) do
            if pnTiming[pn] then
                for i=curStop[pn], #stopList[pn] or 0 do
                    if sec >= stopList[pn][i].Begin then
                        if sec < stopList[pn][i].End then
                            curStop[pn] = i
                            isPnStop[pn] = true
                            break
                        end
                    end
                end
            else
                isPnStop[pn] = isStop
            end
        end
        MESSAGEMAN:Broadcast('ScreenUpdate', {
            Song     = song or nil,
            Beat     = beat,
            Sec      = sec,
            Gameplay = true,
            PnBeat   = {
                PlayerNumber_P1 = pnTiming[PLAYER_1] and pnTiming[PLAYER_1]:GetBeatFromElapsedTime(sec) or 0,
                PlayerNumber_P2 = pnTiming[PLAYER_2] and pnTiming[PLAYER_2]:GetBeatFromElapsedTime(sec) or 0,
            },
            Stop     = isStop,
            PnStop   = isPnStop,
        })
    end
end

return Def.ActorFrame({
    InitCommand = function(self)
        self:SetUpdateFunction(update)
    end,
    -- ステージが変化した時に発行
    -- コースモードはScreenGameplay next course song.luaに定義
    OnCommand = function(self)
        song = W:Song()
        if song then
            pnTiming = {}
            curStop  = {}
            for _,pn in pairs(PlayerNumber) do
                curStop[pn] = 1
                stopList[pn] = {}
                local steps = W:Steps(W_PLAYER:IsEnabled(pn) and pn or W:APn(pn))
                if steps then
                    pnTiming[pn] = steps:GetTimingData()
                    for _,target in pairs({pnTiming[pn]:GetStops(), pnTiming[pn]:GetDelays()}) do
                        for _,data in pairs(target) do
                            local pos = tonumber(split('=', data)[1])
                            local len = tonumber(split('=', data)[2])
                            local sec = pnTiming[pn]:GetElapsedTimeFromBeat(pos)
                            stopList[pn][#stopList[pn]+1] = {Begin = sec, End = sec+len}
                        end
                    end
                    table.sort(stopList[pn], function(a,b) return a.Begin < b.Begin end)
                end
            end
            MESSAGEMAN:Broadcast('ChangedGameplaySong', {
                Song     = song,
                FirstSec = song:GetFirstSecond(),
                LastSec  = song:GetLastSecond(),
                Timing   = pnTiming,
            })
        end
    end,
    ChangedGameplaySongMessageCommand = function(self, params)
        gamePoint = 0
        pnTiming = params.Timing    -- コースモードからも呼ばれるので一度代入し直す
        -- エディット譜面または曲切り替え時点ですでにHereWeGoの条件がそろっている場合は発声しない
        if W_PLAYER:HasEdit() or GAMESTATE:GetSongBeat() >= params.Song:GetFirstBeat()-8 then
            MESSAGEMAN:Broadcast('HereWeGo', {Announcer = false})
        end
    end,
    ScreenUpdateMessageCommand = function(self, params)
        if gamePoint <= 0 then
            if params.Song and params.Beat >= params.Song:GetFirstBeat()-8 then
                -- デモ画面は発声しない
                MESSAGEMAN:Broadcast('HereWeGo', {Announcer = not GAMESTATE:IsDemonstration()})
            end
        elseif gamePoint == 1 then
            if params.Sec >= params.Song:GetFirstSecond() then
                lastCheckBeat = params.Beat
                MESSAGEMAN:Broadcast('FirstBeat')
            end
        else
            if math.floor((params.Beat)/16) > (gamePoint-2) then
                if params.Beat - lastCheckBeat > 1.0 then
                    MESSAGEMAN:Broadcast('While16Beat')
                else
                    gamePoint = gamePoint+1
                end
                lastCheckBeat = params.Beat
            end
        end
    end,
    HereWeGoMessageCommand = function(self)
        gamePoint = 1
    end,
    FirstBeatMessageCommand = function(self)
        gamePoint = 2
    end,
    While16BeatMessageCommand = function(self)
        gamePoint = gamePoint+1
        if gamePoint%2 == 0 then
            MESSAGEMAN:Broadcast('While32Beat')
        end
    end,
})
