varying vec2 vUv;
varying vec2 imageCoord;
uniform sampler2D tDiffuse;
uniform vec2 resolution;
uniform float effectSize;

// ぼかし処理参考
// https://blog.narumium.net/2020/05/08/glsl%E3%81%A7%E7%94%BB%E5%83%8F%E3%81%AE%E3%81%BC%E3%81%8B%E3%81%97%E3%82%84%E5%B9%B3%E6%BB%91%E5%8C%96/

vec4 textureBlur(vec2 fragCoord) {
  vec2 vUv = fragCoord.xy;
  vec2 lr = vec2(1, 0)/resolution;
  vec2 tb = vec2(0, 1)/resolution;
  vec4 color = vec4(0);
  int loop = ceil(effectSize/2);
  for(int i=-loop;i<loop;i++) {
    for(int j=-loop;j<loop;j++) {
      color += texture2D(tDiffuse, vUv+lr*i+tb*j);
    }
  }
  return vec4(color.rgb/color.w, 1.0);
}

void main() {
      gl_FragColor = textureBlur(imageCoord);
}
