local latestSaveVer = W:ReloadParams('Save')
local setup = latestSaveVer or W_OPTION:ReadPref('Setup')
local isConfirm = not setup -- 初回テーマ利用規約確認画面かどうか
local screen
local lock = 0.6
local actorSelf
-- ページ数
local page = isConfirm and 1 or 4
-- 各ページの選択項目数
local values = isConfirm and {2} or {1, 1, 4, 1}
-- 現在のページ
local curPage = 1
-- 初期選択インデックス
local selValues = isConfirm and {2} or {1, 1, 1, 1}

-- 選択された項目の処理
local function SelectedData(pageIndex)
    if selValues[pageIndex] == 3 then
        -- 保存処理
        local optList = {}
        if valueIndex == 2 then
            -- DDR
            optList = {
                ContinueCombo           = 'TapNoteScore_W3',
                BreakComboMineHit       = false,
                BreakComboHoldLetGo     = false,
                RollCombo               = false,
                JudgmentsUnderField     = false,
                ComboUnderField         = true,
                StartMusicTiming        = 'Quick',
                ScoreMode               = 'CLASSIC',
                DifficultyLabel         = 'DDR',
                DifficultyColor         = 'DDR',
                JudgmentMode            = 'DDR',
                DefaultMeterType        = 'DDR',
            }
        elseif selValues[pageIndex] == 3 then
            -- DDR A
            optList = {
                ContinueCombo           = 'TapNoteScore_W4',
                BreakComboMineHit       = true,
                BreakComboHoldLetGo     = true,
                RollCombo               = false,
                JudgmentsUnderField     = false,
                ComboUnderField         = false,
                StartMusicTiming        = 'Quick',
                ScoreMode               = 'A',
                DifficultyLabel         = 'DDR',
                DifficultyColor         = 'DDR',
                JudgmentMode            = 'SuperNOVA',
                DefaultMeterType        = 'DDR X',
            }
        elseif selValues[pageIndex] == 4 then
            -- ITG
            optList = {
                ContinueCombo           = 'TapNoteScore_W3',
                BreakComboMineHit       = false,
                BreakComboHoldLetGo     = false,
                RollCombo               = false,
                JudgmentsUnderField     = false,
                ComboUnderField         = true,
                StartMusicTiming        = 'Slowly',
                ScoreMode               = 'Hybrid',
                DifficultyLabel         = 'SM',
                DifficultyColor         = 'SM',
                JudgmentMode            = 'StepMania',
                DefaultMeterType        = 'ITG',
            }
        end
        for k,v in pairs(optList) do
            W_OPTION:SavePref(k, v)
        end
    end
end

-- キー・マウス操作
local function CallbackInput(params)
    local function CheckButton(params, key)
        return (params.button and params.button == key)
            or (params.GameButton and params.GameButton == key)
    end

    if params.type == 'InputEventType_Release' then
        if CheckButton(params, 'Back') then
            actorSelf:playcommand('Key', {Name = 'Back'})
        end
        if CheckButton(params, 'Start') then
            actorSelf:playcommand('Key', {Name = 'Start'})
        end
    end
    if params.type == 'InputEventType_FirstPress' or params.type == 'InputEventType_Repeat' then
        if CheckButton(params, 'Up') then
            actorSelf:playcommand('Key', {Name = 'Up'})
        end
        if CheckButton(params, 'Down') then
            actorSelf:playcommand('Key', {Name = 'Down'})
        end
        if CheckButton(params, 'Left') then
            actorSelf:playcommand('Key', {Name = 'Left'})
        end
        if CheckButton(params, 'Right') then
            actorSelf:playcommand('Key', {Name = 'Right'})
        end
    end
end

return Def.ActorFrame({
    KeyCommand = function(self, params)
        if params.Name == 'Left' then
            if selValues[curPage] > 1 then
                SOUND:PlayOnce(THEME:GetPathS('Common', 'value'), true)
                selValues[curPage] = selValues[curPage]-1
                MESSAGEMAN:Broadcast('ChangedValue', {Page = curPage, Value = selValues[curPage]})
            end
        end
        if params.Name == 'Right' then
            if selValues[curPage] < values[curPage] then
                SOUND:PlayOnce(THEME:GetPathS('Common', 'value'), true)
                selValues[curPage] = selValues[curPage]+1
                MESSAGEMAN:Broadcast('ChangedValue', {Page = curPage, Value = selValues[curPage]})
            end
        end
        if params.Name == 'Back' then
            if curPage > 1 then
                SOUND:PlayOnce(THEME:GetPathS('Common', 'cancel'), true)
                curPage = curPage-1
                -- 前のページへ
                local prm = {Page = curPage}
                if values[curPage] > 1 then prm.Value = selValues[curPage] end
                MESSAGEMAN:Broadcast('ChangedPage', prm)
                if values[curPage] > 1 then
                    MESSAGEMAN:Broadcast('ChangedValue', prm)
                end
            end
        end
        if params.Name == 'Start' then
            SOUND:PlayOnce(THEME:GetPathS('Common', 'start'), true)
            curPage = curPage+1
            if curPage > page then
                -- 最終ページで押された
                if not setup then
                    if selValues[curPage-1] == 2 then
                        THEME:SetTheme('Default')
                    else
                        MESSAGEMAN:Broadcast('Finish', {Save = '0'})
                    end
                else
                    MESSAGEMAN:Broadcast('Finish', {Save = W:Ver()})
                end
            else
                -- 選択された内容を確認（項目が1つしかない場合は無視）
                if values[curPage-1] > 1 then
                    SelectedData(curPage-1)
                end
                -- 次のページへ
                local prm = {Page = curPage}
                if values[curPage] > 1 then prm.Value = selValues[curPage] end
                MESSAGEMAN:Broadcast('ChangedPage', prm)
                if values[curPage] > 1 then
                    MESSAGEMAN:Broadcast('ChangedValue', {Page = curPage, Value = selValues[curPage]})
                end
            end
        end
    end,
    InitCommand = function(self)
        actorSelf = self
    end,
    OnCommand = function(self)
        screen = SCREENMAN:GetTopScreen()
        screen:lockinput(lock)
        screen:AddInputCallback(CallbackInput)
        MESSAGEMAN:Broadcast('ChangedPage', {Page = curPage})
    end,
    FinishMessageCommand = function(self, params)
        W_OPTION:SavePref('Setup', params.Save)
        W:Reload('ScreenInit', params)
    end,
})