local lock = 0.6

return Def.ActorFrame({
    StartMessageCommand = function(self, ...)
        local params = ...
        if not params or (params.SE == nil or params.SE == true) then
            self:playcommand('PlayStartSound')
        end
    end,
    -- 終了処理
    EndCustomMessageCommand = function(self, ...)
        local params = ...
        if not params or (params.SE == nil or params.SE == true) then
            self:playcommand('PlayCancelSound')
        end
        SCREENMAN:GetTopScreen():lockinput(lock)
        self:sleep(lock)
        self:queuecommand('BackScreen')
    end,
    -- 終了アニメーション後
    BackScreenCommand = function(self)
        W_CUSTOM:End()
        SCREENMAN:GetTopScreen():Cancel()
    end,
    -- 終了アニメーション
    Def.Quad({
        InitCommand = function(self)
            self:Center()
            self:FullScreen()
            self:diffuse(0, 0, 0, 0)
        end,
        EndCustomMessageCommand = function(self)
            self:addx(-SCREEN_CENTER_X)
            self:diffusealpha(1)
            self:faderight(1)
            self:linear(0.2)
            self:faderight(0)
            self:addx(SCREEN_CENTER_X)
        end,
    }),

    LoadActor(THEME:GetPathS('Common', 'start'))..{
        InitCommand = function(self) W:SE(self) end,
        PlayStartSoundCommand = function(self)
            self:play()
        end,
    },
    LoadActor(THEME:GetPathS('Common', 'cancel'))..{
        InitCommand = function(self) W:SE(self) end,
        PlayCancelSoundCommand = function(self)
            self:play()
        end,
    },
    LoadActor(THEME:GetPathS('Common', 'value'))..{
        InitCommand = function(self) W:SE(self) end,
        ScrollMenuMessageCommand = function(self, params)
            if not params.Init then
                self:play()
            end
        end,
        PlayCursorSoundCommand = function(self)
            self:play()
        end,
    },
})