local screen
local lock = 0.6

local customList = {}
local current = getenv('WAIEI_SelectCustom') or 1

local currentName = ''

local function CallbackMainInput(params)
    if params.type == 'InputEventType_FirstPress' then
        if params.button == 'Start' then
            if #customList>0 then
                MESSAGEMAN:Broadcast('Start')
            else
                MESSAGEMAN:Broadcast('GoTitle')
            end
        end
        if params.button == 'Back' then
            MESSAGEMAN:Broadcast('GoTitle')
        end
    end
    if params.type == 'InputEventType_FirstPress' or params.type == 'InputEventType_Repeat' then
        if params.button == 'Up' or params.button == 'Left' then
            if current > 1 then
                current = current-1
            else
                current = #customList
            end
            MESSAGEMAN:Broadcast('ScrollMenu', {Cursor = current})
        end
        if params.button == 'Down' or params.button == 'Right' then
            if current < #customList then
                current = current+1
            else
                current = 1
            end
            MESSAGEMAN:Broadcast('ScrollMenu', {Cursor = current})
        end
    end
end

return Def.ActorFrame({
    Def.Actor({
        OnCommand = function(self)
            screen = SCREENMAN:GetTopScreen()
            screen:lockinput(lock)
            screen:AddInputCallback(CallbackMainInput)
        end,
        GetCustomListMessageCommand = function(self, params)
            customList = params.List
            current = math.min(#customList, math.max(1, current))
            MESSAGEMAN:Broadcast('ScrollMenu', {Cursor = current, Init = true})
        end,
        ScrollMenuMessageCommand = function()
            currentName = (#customList>0) and customList[current].Name or ''
        end,
        StartMessageCommand = function(self)
            setenv('WAIEI_SelectCustom', current)
            screen:lockinput(lock)
            self:sleep(lock)
            self:queuecommand('NextScreen')
        end,
        NextScreenCommand = function(self)
            if currentName ~= '' then
                W_CUSTOM:Start(currentName)
            end
        end,
        GoTitleMessageCommand = function(self)
            setenv('WAIEI_SelectCustom', nil)
            screen:lockinput(lock)
            self:sleep(lock)
            self:queuecommand('BackScreen')
        end,
        BackScreenCommand = function(self)
            screen:Cancel()
        end,
    }),
    Def.Quad({
        InitCommand = function(self)
            self:zoomto(SCREEN_WIDTH, SCREEN_HEIGHT)
            self:diffuse(0, 0, 0, 0)
        end,
        GoTitleMessageCommand = function(self)
            SCREENMAN:GetTopScreen():Cancel()
        end,
        StartMessageCommand = function(self)
            self:linear(lock)
            self:diffusealpha(1)
        end,
    }),
    LoadActor(THEME:GetPathS('Common', 'start'))..{
        InitCommand = function(self) W:SE(self) end,
        StartMessageCommand = function(self)
            self:play()
        end,
    },
    LoadActor(THEME:GetPathS('Common', 'cancel'))..{
        InitCommand = function(self) W:SE(self) end,
        GoTitleMessageCommand = function(self)
            self:play()
        end,
    },
    LoadActor(THEME:GetPathS('Common', 'value'))..{
        InitCommand = function(self) W:SE(self) end,
        ScrollMenuMessageCommand = function(self, params)
            if not params.Init then
                self:play()
            end
        end,
    },
})
