local pn = ...
local mpn = GAMESTATE:GetMasterPlayerNumber()
local ss = STATSMAN:GetCurStageStats()
local pss = ss:GetPlayerStageStats(pn)
local steps = GAMESTATE:IsCourseMode()
                and GAMESTATE:GetCurrentTrail(mpn)
                or W:Steps(pn)
local dif = steps:GetDifficulty()

local difFrameWidth = 410

local difFrame = LoadActor(W:Object('radius'), {
    Id     = 'DifficultFrame'..((p == PLAYER_1) and 1 or 2),
    Width  = difFrameWidth,
    Height = 55,
    Color  = BoostColor(W_DIF:Color(dif), 0.5),
    Cell   = {1, 1, 1, 1, 1, 1, 1, 1, 1},
    Radius = 30,
})
local difFrameOver = LoadActor(W:Object('radius'), {
    Id     = 'DifficultFrame'..((p == PLAYER_1) and 1 or 2),
    Width  = difFrameWidth-4,
    Height = 55-4,
    Color  = color('#000000ff'),
    Cell   = {1, 1, 1, 1, 1, 1, 1, 1, 1},
    Radius = 30,
})

return Def.ActorFrame({
    Def.ActorFrame({
        LoadActor('note', pn, pss),
        InitCommand = function(self)
            local add = 200
            self:xy(SCREEN_CENTER_X + ((pn==PLAYER_1) and add or -add), 395+SCREEN_HEIGHT/2)
        end,
        OffCommand = function(self)
            -- オートプレイを使用していない場合のみライバルスコアを保存
            local noteScore = getenv('WAIEI_NoteScore')[pn] or {}
            if not noteScore.UsingAutoplay then
                W_TARGET:SaveScore(pn)
            end
            self:accelerate(0.4)
            self:y(SCREEN_HEIGHT + 200)
        end,
        HideDetailMessageCommand = function(self, params)
            self:stoptweening()
            self:linear(0.2)
            self:y(395+SCREEN_HEIGHT/2)
        end,
        ShowDetailMessageCommand = function(self, params)
            if pn ~= params.Player then return end
            self:stoptweening()
            self:linear(0.2)
            self:y(395)
        end,
    }),
    Def.ActorFrame({
        InitCommand = function(self)
            local add = SCREEN_CENTER_X/2
            self:x(SCREEN_CENTER_X + ((pn==PLAYER_1) and -add or add))
        end,
        OffCommand = function(self)
            self:accelerate(0.4)
            self:addx(W:IsP1(pn) and -SCREEN_CENTER_X or SCREEN_CENTER_X)
            self:diffusealpha(0)
            self:sleep(0.2)
        end,
        LoadActor('panel', pn, pss)..{
            OnCommand = function(self)
                self:x((854-SCREEN_WIDTH)/4.5 * ((pn==PLAYER_1) and -1 or 1))
                self:y(38)
                self:addy(-200)
                self:rotationz(3)
                self:bounceend(0.3)
                self:rotationz(0)
                self:addy(200)
            end,
        },
        LoadActor('fullcombo_bg', pn, pss)..{
            OnCommand = function(self)
                local add = SCREEN_CENTER_X/2
                self:x((pn==PLAYER_1) and -add or add)
                self:y(SCREEN_BOTTOM-83)
                self:playcommand('Redraw', {
                    Player = pn,
                })
            end,
        },
        -- グレード、スコア
        LoadActor('score', pn, pss)..{
            OnCommand = function(self)
                self:y(345)
            end,
        },
        -- 難易度
        Def.ActorFrame({
            OnCommand = function(self)
                self:x((W:IsP1(pn) and -1 or 1) * 70)
                self:y(SCREEN_BOTTOM - 70)
            end,
            -- 枠
            Def.ActorFrame({
                OnCommand = function(self)
                    self:xy(W:IsP1(pn) and -20 or 20, 18)
                    self:diffusealpha(0.5)
                end,
                difFrame:Actor(),
                difFrameOver:Actor(),
                Def.Quad({
                    OnCommand = function(self)
                        self:diffuse(1, 1, 1, 0.5)
                        self:y(9)
                        self:fadeleft(0.25)
                        self:faderight(0.25)
                        self:zoomto(difFrameWidth-10, 1)
                    end,
                }),
            }),
            -- 難易度
            LoadActor('difficulty', pn, ss)..{
                OnCommand = function(self)
                    self:x(W:IsP1(pn) and 0 or 25*(SCREEN_WIDTH-640)/254)
                end,
            },
            --[[
            -- アバター
            W_AVATAR:Frame(W_PLAYER:Avatar(pn), 'Avatar'..pname(pn), {
                Flip  = W:IsP1(pn),
                Mini  = true,
                Color = BoostColor(playerColor, 0.5),
            })..{
                InitCommand = function(self)
                    self:zoom(0.32)
                    self:xy(W:IsP1(pn) and 158 or -158, 18)
                end,
                OnCommand = function(self)
                    -- ハイスコア以上の時は勝利顔
                    if diffPercent > -0.001 then
                        self:playcommand('WinEmotion', {})
                    end
                end,
            },
            --]]
            -- オプション
            LoadFont('Common Normal')..{
                Text = "",
                OnCommand = function(self)
                    self:horizalign(W:IsP1(pn) and left or right)
                    self:vertalign(top)
                    self:xy((W:IsP1(pn) and -1 or 1) * (80 + (SCREEN_WIDTH-640)/8), 32)
                    self:zoom(0.4)
                    self:maxwidth((245 + (SCREEN_WIDTH-640)/8) / 0.4)
                    self:diffuse(BoostColor(Color('White'), 0.8))
                    -- なぜか言語ファイルが機能していない？
                    self:settext(W_PLAYER:GameplayMods(pn))
                end,
            },
        }),
        HideDetailMessageCommand = function(self, params)
            self:stoptweening()
            self:linear(0.2)
            self:diffusealpha(1)
        end,
        ShowDetailMessageCommand = function(self, params)
            if pn == params.Player then return end
            self:stoptweening()
            self:linear(0.2)
            self:diffusealpha(0)
        end,
    }),
})
