local function PlayerActor()
    local t = Def.ActorFrame({})
    for p=1, 2 do
        local pn = (p==1) and PLAYER_1 or PLAYER_2
        if GAMESTATE:IsPlayerEnabled(pn) then
            t[#t+1] = LoadActor('_parts/player', pn)
        end
    end
    return t
end

return Def.ActorFrame({
    Def.ActorFrame({
        OffCommand = function(self)
            self:sleep(0.4)
            self:linear(0.2)
            self:zoomx(2)
            self:diffusealpha(0)
        end,
        Def.Quad({
            OnCommand = function(self)
                self:diffuse(0, 0, 0, 0.75)
                self:vertalign(bottom)
                self:xy(SCREEN_CENTER_X, SCREEN_BOTTOM)
                self:zoomto(SCREEN_WIDTH, 165)
            end,
        }),
        Def.Quad({
            OnCommand = function(self)
                self:diffuse(1, 1, 1, 1)
                self:vertalign(bottom)
                self:xy(SCREEN_CENTER_X, SCREEN_BOTTOM - 165)
                self:zoomto(SCREEN_WIDTH, 1)
                self:fadeleft(1)
                self:faderight(1)
            end,
        }),
    }),
    -- プレイヤー情報
    PlayerActor(),
    -- 曲情報
    LoadActor('_parts/song')..{
        OnCommand = function(self)
            self:xy(SCREEN_CENTER_X, SCREEN_CENTER_Y-82)
        end,
        OffCommand = function(self)
            self:accelerate(0.4)
            self:y(-SCREEN_HEIGHT)
        end,
        HideDetailMessageCommand = function(self)
            self:stoptweening()
            self:linear(0.2)
            self:x(SCREEN_CENTER_X)
        end,
        ShowDetailMessageCommand = function(self, params)
            self:stoptweening()
            self:linear(0.2)
            self:x(SCREEN_CENTER_X + ((params.Player == PLAYER_1) and 200 or -200))
        end,
    },
    -- ステージカウント、設定
    LoadActor('_parts/stage')..{
        OnCommand = function(self)
            self:xy(SCREEN_CENTER_X, SCREEN_BOTTOM - 55)
        end,
        OffCommand = function(self)
            self:accelerate(0.4)
            self:y(SCREEN_BOTTOM + 100)
        end,
    },
    Def.HelpDisplay({
        File = 'Common Small Normal',
        InitCommand=function(self)
            self:diffuse(Color('White'))
            self:zoom(0.4);
            self:xy(SCREEN_CENTER_X, SCREEN_HEIGHT-12)
            self:SetTipsColonSeparated(THEME:GetString('ScreenEvaluation', 'HelperText'))
        end,
        OffCommand = function(self)
            self:sleep(0.2)
            self:linear(0.3)
            self:addy(30)
        end,
    }),
})
