-- 難易度
local pn = ...
local difficulty
local MeterType = LoadActor(W:Object('radius'), {
    Width  = 48,
    Height = 10,
    Radius = 10,
    Color  = color('#333333ff'),
})
local MeterTypeOver = LoadActor(W:Object('radius'), {
    Width  = 48,
    Height = 10,
    Radius = 10,
    Color  = color('#666666ff'),
    Fill   = false,
})
MeterType:Id('Player'..(W:IsP1(pn) and 1 or 2))
MeterTypeOver:Id('PlayerOver'..(W:IsP1(pn) and 1 or 2))

return Def.ActorFrame{
    OnCommand = function(self)
        self:addx((W:IsP1(pn) and -1 or 1) * 100)
        self:diffusealpha(0)
        self:sleep(W_TIMER:GameStartSleep()+0.3)
        self:smooth(0.5)
        self:addx((W:IsP1(pn) and 1 or -1) * 100)
        self:diffusealpha(1)
    end,
    ChangedGameplaySongMessageCommand = function(self, params)
        local steps = W:Steps(pn)
        difficulty = steps:GetDifficulty()
        self:playcommand('ChangedPlayerDifficulty', {
            Player     = pn,
            Steps      = steps,
            Difficulty = difficulty,
        })
    end,
    Def.Quad({
        InitCommand = function(self)
            self:horizalign(W:IsP1(pn) and left or right)
            self:vertalign(bottom)
            self:y(5)
            self:zoomto(150, 15)
        end,
        ChangedPlayerDifficultyMessageCommand = function(self, params)
            if params.Player == pn then
                self:diffuse(BoostColor(W_DIF:Color(params.Difficulty), 0.5))
                if pn == PLAYER_1 then
                    self:faderight(0.8)
                else
                    self:fadeleft(0.8)
                end
            end
        end,
    }),
    -- 難易度名
    LoadFont('Common Bold')..{
        Text = '',
        InitCommand = function(self)
            self:horizalign(W:IsP1(pn) and left or right)
            self:vertalign(bottom)
            self:x(W:IsP1(pn) and 10 or -10)
            self:zoom(0.5)
            self:maxwidth(150/0.5)
        end,
        ChangedPlayerDifficultyMessageCommand = function(self, params)
            if params.Player == pn then
                self:diffuse(W_DIF:Color(params.Difficulty))
                self:strokecolor(Color('Outline'))
                if (params.Steps:IsAnEdit() or params.Steps:IsAPlayerEdit()) and params.Steps:GetDescription() ~= '' then
                    --self:settext(string.upper(params.Steps:GetDescription()))
                    self:settext(params.Steps:GetDescription())
                else
                    self:settext(W_DIF:Name(params.Difficulty))
                end
            end
        end,
    },
    -- 数字
    LoadFont('waiei2 Score Numbers')..{
        Text = '',
        InitCommand = function(self)
            self:horizalign(W:IsP1(pn) and left or right)
            self:vertalign(top)
            self:xy(W:IsP1(pn) and 10 or -10, 5)
            self:zoom(1.4)
            self:maxwidth(70/1.5)
        end,
        ChangedPlayerDifficultyMessageCommand = function(self, params)
            if params.Player == pn then
                self:diffuse(W_DIF:Color(params.Difficulty))
                self:strokecolor(Color('Outline'))
                self:settext(params.Steps:GetMeter())
            end
        end,
    },
    -- METERTYPE
    Def.ActorFrame({
        InitCommand = function(self)
            self:xy(W:IsP1(pn) and 20 or -20, 32)
        end,
        MeterType:Actor(),
        MeterTypeOver:Actor(),
        -- 難易度名
        LoadFont('Common Small Normal')..{
            Text = '',
            InitCommand = function(self)
                self:zoom(0.3)
                self:maxwidth(40/0.3)
                self:diffuse(color('#ffffffff'))
            end,
            ChangedGameplaySongMessageCommand = function(self, params)
                self:settext(YA_GROUP:MeterType(W:Song()) or 'DDR')
            end,
        },
    }),
};