local bgColor = ...
local actors = Def.ActorFrame({
    Def.ActorFrame({
        OnCommand = function(self)
            self:xy(SCREEN_CENTER_X, SCREEN_TOP)
        end,
        Def.Quad({
            OnCommand = function(self)
                self:vertalign(top)
                self:zoomto(SCREEN_WIDTH+2, 140)
                self:diffuse(bgColor[1], bgColor[2], bgColor[3], 0)
                self:sleep(W_TIMER:GameStartSleep())
                self:linear(0.2)
                self:diffuse(bgColor)
                self:diffusetopedge(0, 0, 0, bgColor[4]*2/3)
                self:zoomto(SCREEN_WIDTH+2, 50)
            end,
        }),
        -- フレームの境界線（上）
        Def.ActorMultiVertex({
            OnCommand = function(self)
                local col = color('#ffffff00')
                local p1Color = GAMESTATE:IsPlayerEnabled(PLAYER_1) and W_DIF:Color(W:Steps(PLAYER_1):GetDifficulty()) or color('#999999ff')
                local p2Color = GAMESTATE:IsPlayerEnabled(PLAYER_2) and W_DIF:Color(W:Steps(PLAYER_2):GetDifficulty()) or color('#999999ff')
                self:SetDrawState({Mode = 'DrawMode_LineStrip'})
                self:SetLineWidth(1)
                self:SetVertices( 1, {
                    {{-1, 50, 0}, col},
                    {{0, 50, 0}, col},
                    {{1, 50, 0}, col},
                })
                self:sleep(1.5+0.2)
                self:linear(0.3)
                col[4] = 1.0
                self:SetVertices( 1, {
                    {{-SCREEN_CENTER_X/2, 50, 0}, col},
                    {{0, 50, 0}, col},
                    {{SCREEN_CENTER_X/2, 50, 0}, col},
                })
                self:linear(0.3)
                self:SetVertices( 1, {
                    {{-SCREEN_CENTER_X, 50, 0}, p1Color},
                    {{0, 50, 0}, color('#999999ff')},
                    {{SCREEN_CENTER_X, 50, 0}, p2Color},
                })
            end,
        }),
        -- ステージカウント
        LoadFont('Common Small Bold')..{
            OnCommand = function(self)
                self:settext(W_STAGE:String())
                self:y(40)
                self:diffusealpha(0)
                self:zoom(0.5)
                self:sleep(math.min(math.max(W_TIMER:GameStartSleep(), 0.2), 2.0))
                self:sleep(0.4)
                self:linear(0.05)
                self:diffusealpha(1)
                if (bgColor[4] < 0.5) then
                    self:strokecolor(color('0, 0, 0, '..(0.5-bgColor[4])))
                end
            end,
            ChangedGameplaySongMessageCommand = function(self)
                self:settext(W_STAGE:String())
            end,
        },
    })
})

for pn in ivalues(PlayerNumber) do
    if GAMESTATE:IsPlayerEnabled(pn) then
        local p = W:PNum(pn)
        -- ライフ
        actors[#actors+1] = Def.ActorFrame({
            LoadActor('life', pn)..{
                InitCommand = function(self)
                    local x = THEME:GetMetric(Var 'LoadingScreen','PlayerP'..p..'OnePlayerOneSideX')
                    self:xy(x, 25)
                end,
            },
        })
    end
end

return actors