-- フルコンボ
local function PlayerFullcomboActor(pn)
    if not GAMESTATE:IsPlayerEnabled(pn) then
        return Def.ActorFrame({})
    end
    return Def.ActorFrame({
        Name = 'Fullcombo'..pname(pn),
        OffCommand=function(self)
            local fcColor = W_SCORE:FCColor(pn, nil)
            if fcColor then
                self:playcommand('FullCombo', {Color = fcColor})
            end
        end,
        Def.Quad({
            InitCommand=function(self)
                self:zoomto(W_PLAYER:StepZoneW(pn)*2, SCREEN_HEIGHT)
                self:xy(W_PLAYER:StepZoneX(pn), SCREEN_CENTER_Y)
                self:blend('BlendMode_Add')
                self:diffusealpha(0)
                self:fadetop(0.5)
                self:fadebottom(0.5)
            end,
            FullComboCommand=function(self, params)
                self:diffuse(params.Color)
                self:diffusealpha(0.25)
                self:linear(0.2)
                self:zoomto(W_PLAYER:StepZoneW(pn), SCREEN_HEIGHT)
                self:diffusealpha(0.5)
                self:linear(0.8)
                self:zoomto(W_PLAYER:StepZoneW(pn), SCREEN_HEIGHT*2)
                self:diffusealpha(0)
            end,
        }),
        Def.Quad({
            InitCommand=function(self)
                self:zoomto(0, SCREEN_HEIGHT)
                self:xy(W_PLAYER:StepZoneX(pn), SCREEN_CENTER_Y)
                self:blend('BlendMode_Add')
                self:diffusealpha(0)
                self:fadetop(0.5)
                self:fadebottom(0.5)
            end,
            FullComboCommand=function(self, params)
                self:diffuse(params.Color)
                self:diffusealpha(0.25)
                self:linear(0.2)
                self:zoomto(W_PLAYER:StepZoneW(pn), SCREEN_HEIGHT)
                self:diffusealpha(0.5)
                self:linear(0.4)
                self:zoomto(W_PLAYER:StepZoneW(pn)*1.5, SCREEN_HEIGHT*2)
                self:diffusealpha(0)
            end,
        }),
        LoadActor('fan')..{
            InitCommand=function(self)
                self:xy(W_PLAYER:StepZoneX(pn), SCREEN_CENTER_Y)
                self:blend('BlendMode_Add')
                self:diffusealpha(0)
            end,
            FullComboCommand=function(self, params)
                local po = GAMESTATE:GetPlayerState(pn):GetCurrentPlayerOptions()
                self:addy(60 * ((po:Reverse() <= 0.5) and 1 or -1))
                self:diffuse(params.Color)
                self:rotationz(-45)
                self:zoom(3)
                self:diffusealpha(0)
                self:decelerate(0.4)
                self:rotationz(0)
                self:zoom(1.5)
                self:diffusealpha(1)
                self:linear(0.4)
                self:diffusealpha(0)
            end,
        },
    })
end

return Def.ActorFrame({
    PlayerFullcomboActor(PLAYER_1),
    PlayerFullcomboActor(PLAYER_2),
})