local graph = {
    PlayerNumber_P1 = (W_PLAYER:ReadPref(PLAYER_1, 'NoteGraph') or W_OPTION:Name('Off')) ~= W_OPTION:Name('Off'),
    PlayerNumber_P2 = (W_PLAYER:ReadPref(PLAYER_2, 'NoteGraph') or W_OPTION:Name('Off')) ~= W_OPTION:Name('Off'),
}
local frameColor = color(W_OPTION:ReadPref('FrameColor'))
local width = 80
local height = SCREEN_HEIGHT-100-1
local songLastSec = 0
local function GraphActor(pn)
    if graph[pn] and W_PLAYER:IsEnabled(pn) then
        return Def.ActorFrame({
            ChangedGameplaySongMessageCommand = function(self, params)
                if params.Song then
                    songLastSec = params.LastSec
                end
            end,
            LoadActor(W:Object('graph steps'), {
                    Width   = height,
                    Size    = 5,
                    Max     = width,
                    Player  = pn,
                    BgColor = frameColor,
                })..{
                OnCommand= function(self)
                    if pn == PLAYER_1 then
                        self:rotationz(90)
                        self:rotationx(180)
                        self:x(SCREEN_LEFT + 8)
                    else
                        self:rotationz(-90)
                        self:rotationx(0)
                        self:x(SCREEN_RIGHT - 8)
                    end
                    self:y(SCREEN_CENTER_Y)
                    self:zoomy(0)
                    self:addx(-120 * (W:IsP1(pn) and 1 or -1))
                    self:sleep(2)
                    self:addx(120 * (W:IsP1(pn) and 1 or -1))
                    self:decelerate(0.4)
                    self:zoomy(1.0-0.4*math.max(854-SCREEN_WIDTH, 0)/214)
                end,
            },
            -- 横線
           LoadActor(W:Object('border'), {
                From = {
                    Color = color('#ffffffcc'),
                },
                To = {
                    X = W:IsP1(pn) and width or -width, Color = color('#ffffff00'),
                },
            })..{
                ScreenUpdateMessageCommand = function(self, params)
                    self:x(W:IsP1(pn) and SCREEN_LEFT + 8 or SCREEN_RIGHT - 8)
                    self:y(SCREEN_CENTER_Y + height/2 - math.max(math.min(height * params.Sec / songLastSec, height), 0))
                end,
            },
        })
    end
    return Def.ActorFrame({})
end

return Def.ActorFrame({
    -- 譜面グラフ
    GraphActor(PLAYER_1),
    GraphActor(PLAYER_2),
})
