local width = 8
local height = SCREEN_HEIGHT-100-1
local function PositionActor(pn)
    local steps
    local songLastSec = 0
    local songLastBeat = 0
    return Def.ActorFrame({
        OnCommand = function(self)
            self:addx(-1)
            self:zoomto(0, 1)
            self:sleep(W_TIMER:GameStartSleep())
            self:linear(0.2)
            self:addx(1)
            self:zoomto(1, 1)
        end,
        ChangedGameplaySongMessageCommand = function(self, params)
            songLastSec = 0
            if params.Song then
                steps = W:Steps(pn)
                songLastSec = params.LastSec
                songLastBeat = steps:GetTimingData():GetBeatFromElapsedTime(params.LastSec)
                if songLastSec <= 0 then songLastSec = 0.1 end
                if songLastBeat <= 0 then songLastBeat = 0.1 end
            end
        end,
        -- 背景
        Def.Quad({
            InitCommand = function(self)
                self:horizalign(left)
                self:x(0)
                self:diffuse(0, 0, 0, 0.75)
                self:zoomto(width, height)
            end,
        }),
        -- 小節単位
        Def.Quad({
            InitCommand = function(self)
                self:horizalign(left)
                self:vertalign(bottom)
                self:xy(0, height/2)
                self:diffuse(0, 1, 1, 0.5)
                self:zoomto(width/2-1, 0)
            end,
            ScreenUpdateMessageCommand = function(self, params)
                if not steps then return end
                local beat = steps:GetTimingData():GetBeatFromElapsedTime(params.Sec)
                self:zoomto(width/2-1, math.max(math.min(height * beat / songLastBeat, height), 0))
            end,
        }),
        -- 時間単位
        Def.Quad({
            InitCommand = function(self)
                self:horizalign(left)
                self:vertalign(bottom)
                self:xy(width/2, height/2)
                self:diffuse(1, 0, 0, 0.5)
                self:zoomto(width/2-1, 0)
            end,
            ScreenUpdateMessageCommand = function(self, params)
                self:zoomto(width/2-1, math.max(math.min(height * params.Sec / songLastSec, height), 0))
            end,
        }),
        -- 境界線
       LoadActor(W:Object('border'), {
            From = {
                X = width/2-1, Y = -height/2, Color = color('1, 1, 1, 0.25'),
            },
            To = {
                Y = height/2,
            },
        }),
        LoadActor(W:Object('border'), {
             From = {
                 X = width-1, Y = -height/2, Color = color('1, 1, 1, 0.25'),
             },
             To = {
                 Y = height/2,
             },
        }),
    })
end

local actors = Def.ActorFrame({})
for i, pn in ipairs(PlayerNumber) do
    if GAMESTATE:IsPlayerEnabled(pn) then
        actors[#actors+1] = PositionActor(pn)..{
            InitCommand = function(self)
                self:xy(W:IsP1(pn) and SCREEN_LEFT or SCREEN_RIGHT, SCREEN_CENTER_Y)
                self:rotationy(W:IsP1(pn) and 0 or 180)
            end,
        }
    end
end


return actors