local song = W:Song()
local bgBrightness = PREFSMAN:GetPreference('BGBrightness')
bgBrightness = (bgBrightness and bgBrightness~= '') and 1.0 - tonumber(bgBrightness) or 1.0

return Def.ActorFrame({
    OnCommand = function(self)
        self:Center()
        self:sleep(0.5)
        self:linear(0.2)
        self:diffusealpha(0)
    end,
    Def.ActorFrame({
        OnCommand = function(self)
            self:zoom(1.1)
            self:accelerate(0.5)
            self:zoom(1)
        end,
        Def.Quad({
            OnCommand = function(self)
                self:zoomto(0, 0)
                self:xy(0, 0)
                self:diffuse(Color('Black'))
            end,
            SideBlackCommand = function(self)
                local width = self:GetParent():GetChild('BG'):GetWidth()
                self:horizalign(right)
                self:x(-width/2)
                self:zoomto((SCREEN_WIDTH - width)/2, SCREEN_HEIGHT)
            end,
        }),
        Def.Quad({
            OnCommand = function(self)
                self:zoomto(0, 0)
                self:xy(0, 0)
                self:diffuse(Color('Black'))
            end,
            SideBlackCommand = function(self)
                local width = self:GetParent():GetChild('BG'):GetWidth()
                self:horizalign(left)
                self:x(width/2)
                self:zoomto((SCREEN_WIDTH - width)/2, SCREEN_HEIGHT)
            end,
        }),
        Def.Sprite({
            Name = 'BG',
            OnCommand = function(self)
                self:LoadBackground(song:HasBackground()
                    and song:GetBackgroundPath()
                    or THEME:GetPathG('common fallback', 'background'))
                self:scale_or_crop_background()
                self:xy(0, 0)
                self:GetParent():playcommand('SideBlack')
            end,
        }),
        -- 背景の明るさ
        Def.Quad({
            OnCommand = function(self)
                self:zoomto(SCREEN_WIDTH+2, SCREEN_HEIGHT+2)
                self:diffuse(0.1, 0.1, 0.12, 1.0)
                self:accelerate(0.5)
                self:diffuse(0, 0, 0, bgBrightness)
            end,
        }),
    }),
    -- 発光
    Def.Quad({
        OnCommand = function(self)
            self:xy(0, 0)
            self:diffuse(1, 1, 1, 1)
            self:zoomto(SCREEN_WIDTH, SCREEN_HEIGHT)
            self:accelerate(0.2)
            self:diffusealpha(0)
        end,
    }),
})