local bnSize = getenv('WAIEI_BannerSize') or {Width = 256, Height = 80}
--setenv('WAIEI_BannerSize', nil)
local size = 230
local beginHeight = size*bnSize.Height/bnSize.Width
local endHeight = GAMESTATE:IsCourseMode() and beginHeight or size

return Def.ActorFrame({
    OnCommand = function(self)
        self:xy(0, 0)
        self:linear(0.2)
        if GAMESTATE:IsCourseMode() then
            self:y(-20)
            self:zoom(1.5)
        else
            self:zoom(1.2)
        end
    end,
    LoadActor(W:Object('boxshadow'), 'BannerFrame', {
        Length = 6,
        Color  = {0, 0, 0, 0.4},
        Center = {0, 0, 0, 0.8},
    })..{
        OnCommand = function(self, params)
            self:playcommand('UpdateBoxShadow', {
                Id     = 'BannerFrame',
                Width  = size,
                Height = beginHeight,
            })
            self:playcommand('UpdateBoxShadow', {
                Id        = 'BannerFrame',
                Width     = size,
                Height    = endHeight,
                Color     = {1, 1, 1, 0.4},
                Wait      = 0.2,
                AnimeSize = true,
            })
        end,
    },
    Def.Sprite({
        OnCommand = function(self)
            if GAMESTATE:IsCourseMode() then
                self:LoadBanner(W_GRAPHICS:CourseBanner())
            else
                local song = W:Song()
                self:LoadBackground(W_GRAPHICS:SongJacket(song))
            end
            self:scaletofit(-size/2, -size/2, size/2, size/2)
            local texH = self:GetTexture():GetImageHeight()
            self:zoomy(1.0*beginHeight/texH)
            self:linear(0.2)
            self:scaletofit(-size/2, -size/2, size/2, size/2)
        end,
    }),
    Def.Quad({
        OnCommand = function(self)
            self:zoomto(size, beginHeight)
            self:diffuse(1, 1, 1, 1)
            self:linear(0.2)
            self:zoomto(size, endHeight)
            self:diffusealpha(0)
        end,
    }),
})