local offsetY = 30
local courseAddY = GAMESTATE:IsCourseMode() and 70 or 0
local beforeOffset = 260-(854-SCREEN_WIDTH)/3
local afterOffset  = -60
local sleepTime = math.min(math.max(W_TIMER:GameStartSleep(), 0.2), 2.0)
local topColor    = color('0.2, 0.2, 0.2, 1')
local bottomColor = color('0.2, 0.2, 0.2, 1')
return Def.ActorFrame({
    InitCommand = function(self)
        self:xy(-SCREEN_CENTER_X, -SCREEN_CENTER_Y)
        self:addy(offsetY + courseAddY)
    end,
    -- 上フレーム本体
    LoadActor('frame')..{
        InitCommand = function(self)
            self:horizalign(right)
            self:animate(false)
            self:setstate(0)
            self:xy(0, SCREEN_CENTER_Y - 30)
            self:zoomto(0, 60)
            self:diffuse(topColor)
        end,
        OnCommand = function(self)
            self:linear(0.2)
            self:x(SCREEN_RIGHT - beforeOffset)
            self:zoomto(SCREEN_RIGHT + 60 - beforeOffset, 60)
            self:sleep(0.3)
            self:sleep(math.max(sleepTime-0.4, 0))
            self:linear(0.4)
            self:x(SCREEN_RIGHT - afterOffset)
            self:zoomto(SCREEN_RIGHT + 60 - afterOffset, 60)
            self:diffusealpha(0)
            self:fadeleft(1)
        end,
    },
    -- 上フレーム端
    LoadActor('frame')..{
        InitCommand = function(self)
            self:horizalign(left)
            self:animate(false)
            self:setstate(1)
            self:xy(0, SCREEN_CENTER_Y - 30)
            self:diffuse(topColor)
        end,
        OnCommand = function(self)
            self:linear(0.2)
            self:x(SCREEN_RIGHT - beforeOffset)
            self:sleep(0.3)
            self:sleep(math.max(sleepTime-0.4, 0))
            self:linear(0.4)
            self:x(SCREEN_RIGHT - afterOffset)
            self:diffusealpha(0)
        end,
    },
    -- 下フレーム端
    LoadActor('frame')..{
        InitCommand = function(self)
            self:horizalign(right)
            self:animate(false)
            self:setstate(2)
            self:xy(SCREEN_RIGHT, SCREEN_CENTER_Y + 20)
            self:diffuse(bottomColor)
        end,
        OnCommand = function(self)
            self:linear(0.2)
            self:x(beforeOffset)
            self:sleep(0.3)
            self:sleep(math.max(sleepTime-0.4, 0))
            self:linear(0.4)
            self:x(afterOffset)
            self:diffusealpha(0)
        end,
    },
    -- 下フレーム本体
    LoadActor('frame')..{
        InitCommand = function(self)
            self:horizalign(left)
            self:animate(false)
            self:setstate(3)
            self:xy(SCREEN_RIGHT, SCREEN_CENTER_Y + 20)
            self:zoomto(0, 60)
            self:diffuse(bottomColor)
        end,
        OnCommand = function(self)
            self:linear(0.2)
            self:x(beforeOffset)
            self:zoomto(SCREEN_RIGHT + 60 - afterOffset, 60)
            self:sleep(0.3)
            self:sleep(math.max(sleepTime-0.4, 0))
            self:linear(0.4)
            self:x(afterOffset)
            self:zoomto(SCREEN_RIGHT + 60 - afterOffset, 60)
            self:diffusealpha(0)
            self:faderight(1)
        end,
    },
    -- ステージカウント
    LoadFont('Common Bold')..{
        Text = '',
        OnCommand = function(self)
            self:xy(0, SCREEN_CENTER_Y - 32)
            self:diffusealpha(0)
            self:linear(0.2)
            self:diffusealpha(1)
            self:x(SCREEN_CENTER_X)
            self:sleep(sleepTime)
            self:linear(0.2)
            self:y(10 - courseAddY)
            self:zoom(0.5)
            self:linear(0.05)
            self:diffusealpha(0)
        end,
        ChangedGameplaySongMessageCommand = function(self)
            if GAMESTATE:IsCourseMode() then
                self:settext(W_STAGE:Convert(GAMESTATE:GetCurrentCourse():GetCourseType()))
            else
                self:settext(W_STAGE:String())
            end
        end,
    },
    -- 曲名
    LoadActor(W:Object('song title'), {
        Width    = 330,
        IsCenter = true,
    })..{
        OnCommand = function(self)
            self:xy(SCREEN_RIGHT, SCREEN_CENTER_Y + 18)
            self:zoom(0.8)
            if GAMESTATE:IsCourseMode() then
                local fullTitle = YA_GROUP:GroupName(GAMESTATE:GetCurrentCourse():GetDisplayFullTitle())
                local match = string.match(fullTitle, '(.+) Random')
                if match then
                    fullTitle = YA_GROUP:GroupName(match)..' Random'
                end
                self:playcommand('ChangedSong', {Name = fullTitle})
            else
                self:playcommand('ChangedSong', {Song = W:Song()})
            end
            self:playcommand('UpdateText', {
                Sleep    = sleepTime+0.5,
                Anime    = 0.2,
                Width    = 330,
                MainZoom = 0.85,
            })
        end,
        UpdateTextCommand = function(self,params)
            self:diffusealpha(0)
            self:linear(0.2)
            self:diffusealpha(1)
            self:x(SCREEN_CENTER_X)
            self:sleep(sleepTime)
            self:linear(0.2)
            self:y(SCREEN_BOTTOM - 46 - offsetY - courseAddY)
            self:zoom(0.65)
            self:linear(0.05)
            self:diffusealpha(0)
        end,
    },
})