local chara, stageType = ...
local actors = Def.ActorFrame({})

if not chara then return actors end

local dancerSpeed = W_OPTION:ReadPref('DancerSpeed', 'Default') -- or SyncBPM
local function DancerSpeed(bpm)
    return (dancerSpeed == 'Default') and 1.0*math.min(math.max(120.0 + ((bpm > 120) and (bpm-120.0)/2 or (bpm-120.0)*4/5), 15), 220) or bpm
end

local model = chara:GetModelPath()
local ini = IniFile.ReadFile(chara:GetCharacterDir()..'/character.ini')
local command = ini.Character and ini.Character.InitCommand or nil


local anime = {
    {Name = 'Rest'  , Path = chara:GetRestAnimationPath()},
    {Name = 'WarmUp', Path = chara:GetWarmUpAnimationPath()},
    {Name = 'Anime1', Path = chara:GetDanceAnimationPath()},
    {Name = 'Anime2', Path = chara:GetDanceAnimationPath()},
    {Name = 'Anime3', Path = chara:GetDanceAnimationPath()},
    {Name = 'Anime4', Path = chara:GetDanceAnimationPath()},
}
local currentAnime = -1
local currentBpm = 120.000
for i=1, 6 do
    actors[#actors+1] = Def.Model({
        Meshes = model,
        Materials = model,
        Bones = anime[i].Path,
        InitCommand = function(self)
            self:cullmode('CullMode_None')
            if anime[i].Name == 'Rest' then
                self:visible(true)
                currentAnime = i
            else
                self:visible(false)
            end
            if command then
                (loadstring("return cmd("..command..")")())(self)
            end
            if stageType == 'enciso' then
                -- とくにサイズの調整をする必要はなさそう
                -- self:zoom(720.0 * self:GetZoom() / 1080.0)
            end
        end,
        ChangeDancerBoneCommand = function(self, params)
            self:finishtweening()
            if params.Bone == anime[i].Name then
                currentAnime = i
                self:visible(true)
                self:rate(DancerSpeed(currentBpm)/120.0)
            else
                self:visible(false)
                self:rate(0)
            end
        end,
        ChangedBpmCommand = function(self, params)
            if currentAnime == i then
                currentBpm = params.Bpm
                self:playcommand('ChangeDancerBone', {Bone = anime[i].Name})
            end
        end,
    })
end
return actors