local width, height = ...

return Def.ActorFrame({
    OnCommand = function(self)
        self:y(30)
        self:addy(200)
        self:diffusealpha(0)
        self:linear(0.2)
        self:addy(-200)
        self:diffusealpha(1)
    end,
    OffMessageCommand = function(self)
        self:linear(0.2)
        self:addy(200)
        self:diffusealpha(0.8)
    end,
    LoadActor(W:Object('boxshadow'), 'Background', {
        Length = 20,
        Color  = {0, 0, 0, 0.8},
        Center = {0, 0.1, 0.2, 0.5},
    })..{
        OnCommand = function(self, params)
            self:playcommand('UpdateBoxShadow', {
                Id         = 'Background',
                Width      = width,
                Height     = height,
            })
        end,
    },
    Def.HelpDisplay({
        File = 'Common Small Normal',
        InitCommand=function(self)
            self:diffuse(Color('White'))
            self:zoom(0.4);
            self:xy(0, height/2-12)
            self:SetSecsBetweenSwitches(3.0)
            self:SetTipsColonSeparated(THEME:GetString('ScreenSelectMusicOptions', 'HelperText'))
        end,
    }),
})
