local bgX = 1000000000
local newBgX = bgX
local bgMove = 10
local latestLR = nil

local function CallInput(params)
    if params.type == 'InputEventType_FirstPress' and params.PlayerNumber and W_PLAYER:IsEnabled(params.PlayerNumber) then
        latestLR = nil
        if params.button == 'Left' or params.button == 'MenuLeft' then
            latestLR = 'Left'
        elseif params.button == 'Right' or params.button == 'MenuRight' then
            latestLR = 'Right'
        end
    end
end

local fps      = 1.0/60
local timer    = 0
local oldTimer = 0
local speed    = 0.1
local border   = 0.75
local function updateWheelBgScroll(self, delta)
    timer = timer + delta
    if timer - oldTimer >= fps then
        if bgX ~= newBgX then
            local add = newBgX - bgX
            -- 移動
            if math.abs(add) > border then
                bgX = bgX + ((add > 0) and math.max(speed * add, border) or math.min(speed * add, -border))
            -- 停止
            else
                bgX = newBgX
            end
            self:playcommand('UpdateWheelBgScroll')
        end
        oldTimer = oldTimer + fps
    end
end

return Def.ActorFrame({
    InitCommand = function(self)
        self:SetUpdateFunction(updateWheelBgScroll)
    end,
    OnCommand = function(self)
        SCREENMAN:GetTopScreen():AddInputCallback(CallInput)
    end,
    LoadActor('bg '..string.format('%02d', math.floor(0.01*math.random(799))+1))..{
        OnCommand = function(self)
            self:vertalign(top)
            self:y(-math.random(250) - SCREEN_CENTER_Y)
            self:bob()
            self:effectmagnitude(70, 0, 0)
            self:effectperiod(100)
        end,
    },
    Def.Quad({
        InitCommand = function(self)
            self:FullScreen()
            self:xy(0,0)
            self:diffuse(1, 1, 1, 0)
        end,
        OffCommand= function(self)
            self:linear(0.2)
            self:diffusealpha(1)
        end,
    }),
    Def.ActorFrame({
        OffCommand= function(self)
            self:sleep(0.2)
            self:linear(0.2)
            self:addy(SCREEN_HEIGHT-150)
            self:diffusealpha(0)
        end,
        Def.Quad({
            InitCommand = function(self)
                self:vertalign(bottom)
                self:xy(0, SCREEN_CENTER_Y)
                self:zoomto(SCREEN_WIDTH, SCREEN_HEIGHT-150)
                self:diffuse(color('#182028ff'))
            end,
        }),
        Def.Quad({
            InitCommand = function(self)
                self:vertalign(bottom)
                self:xy(0, SCREEN_CENTER_Y)
                self:zoomto(SCREEN_WIDTH, SCREEN_HEIGHT-150)
                self:diffuse(color('#00000000'))
                -- self:diffuselowerleft(color('#3333cc40'))
                -- self:diffuselowerright(color('#0066cc40'))
            end,
        }),
    }),
    Def.ActorFrame({
        LoadActor('overlay')..{
            InitCommand = function(self)
                self:blend('BlendMode_Add')
                self:vertalign(top)
                self:x(0)
                self:fadetop(0.8)
            end,
        },
        LoadActor('overlay')..{
            InitCommand = function(self)
                self:blend('BlendMode_Add')
                self:vertalign(top)
                self:x(960)
                self:fadetop(0.8)
            end,
        },
        OnCommand = function(self)
            self:xy(bgX%960-960, -SCREEN_CENTER_Y+150+140)
            self:diffuseshift()
            self:effectperiod(10)
            self:effectcolor1(1, 1, 1, 0.3)
            self:effectcolor2(1, 1, 1, 0.8)
        end,
        CurrentSongChangedMessageCommand = function(self)
            if latestLR then
                newBgX = (bgX + ((latestLR == 'Left') and 1 or -1) * bgMove)
            end
        end,
        UpdateWheelBgScrollMessageCommand = function(self, params)
            self:x(bgX%960-960)
        end,
        OffCommand = function(self)
            self:stoptweening()
        end,
    }),
})
