local areaWidth = math.min(SCREEN_WIDTH/4, 200)

-- actors
return Def.ActorFrame({
  LoadActor('_functions'),
  -- メトロノーム
  LoadActor('metronome', areaWidth/4)..{
      InitCommand = function(self)
          self:xy(areaWidth/2 ,-10)
      end,
  };
  -- スペクトラム
  LoadActor('spectrum', areaWidth, 40)..{
      OnCommand = function(self)
          self:xy(areaWidth/2, -33)
      end,
  },
  -- Split BPM
  LoadActor('splitbpm', areaWidth),
  -- True BPM
  LoadActor('truebpm', areaWidth),
  -- LabelとValue
  LoadActor('bpmvalue', 'BPM', color('1, 1, 1, 0.75')),
  LoadActor('bpmvalue', 'Player1', BoostColor(W_PLAYER:Color(PLAYER_1), 1.5))..{
    OnCommand = function(self)
      self:playcommand('UpdateBpmLabels', {ShowTrueBpm = false})
    end,
    UpdateBpmLabelsCommand = function(self)
      self:visible(W_PLAYER:IsEnabled(PLAYER_1))
    end,
  },
  LoadActor('bpmvalue', 'Player2', BoostColor(W_PLAYER:Color(PLAYER_2), 1.5))..{
    OnCommand = function(self)
      self:playcommand('UpdateBpmLabels', {ShowTrueBpm = false})
    end,
    UpdateBpmLabelsCommand = function(self)
      -- P2はP1が参加しているときだけ右にずらす
      self:x(W_PLAYER:IsEnabled(PLAYER_1) and areaWidth/2 or 0)
      self:visible(W_PLAYER:IsEnabled(PLAYER_2))
    end,
  },
})