local stageList = {
    Stage_1st    = '1st.png',
    Stage_2nd    = '2nd.png',
    Stage_3rd    = '3rd.png',
    Stage_4th    = '4th.png',
    Stage_5th    = '5th.png',
    Stage_Final  = 'final.png',
    Stage_Extra1 = 'extra.png',
    Stage_Extra2 = 'special.png',
    Stage_Exf1   = 'exf1.png',
    Stage_Exf2   = 'exf1.png',
    Stage_Other  = 'stage.png',
    Stage_Course = 'course.png',
}

return Def.ActorFrame({
    Def.Quad({
        OnCommand = function(self)
            self:vertalign(top)
            self:y(-20)
            self:zoomto(90, 160)
            self:diffuse(1, 1, 1, 0.75)
        end,
    }),
    -- 時計
    LoadActor(W:Object('clock'), color('1, 1, 1, 0.75'))..{
        OnCommand = function(self)
            self:y(35)
        end,
    },
    -- 画像
    Def.Sprite({
        Name = 'Text',
        OnCommand = function(self)
            self:vertalign(top)
            self:y(85)
            self:zoom(0.5)
        end,
    }),
    -- 6ステージ目以降の数字
    LoadFont('Common Bold')..{
        Name = 'Number',
        OnCommand = function(self)
            self:vertalign(top)
            self:y(112)
            self:zoom(1.5)
            self:diffuse(color('#1166aaff'))
        end,
    },
    OnCommand = function(self)
        self:x(-255)
        self:y(-SCREEN_CENTER_Y)

        local child = self:GetChildren()
        local curStage, stageNumber = W_STAGE:Current()
        if GAMESTATE:IsCourseMode() then
            curStage = 'Stage_Course'
        end
        -- EXF以外またはstageListに存在する
        if stageList[curStage] then
            child.Number:visible(false)
        else
            -- EXFまたは6th以上
            curStage = 'Stage_Other'
            child.Number:visible(true)
            child.Number:settext(stageNumber)
        end
        child.Text:Load(ResolveRelativePath(stageList[curStage], 1))

        self:addy(-140)
        self:sleep(0.3)
        self:bounceend(0.2)
        self:addy(140)
    end,
    OffCommand = function(self)
        self:bouncebegin(0.4)
        self:addy(-140)
    end,
})