local width = 65
local x = 75

-- プレイヤーごとのスコア表示
local function PlayerScoreActor(pn)
    return LoadFont('Common Small Bold')..{
        Text = '',
        InitCommand = function(self)
            self:visible(W_PLAYER:IsEnabled(pn))
            self:diffuse(Color('White'))
            self:diffusealpha(0.8)
            self:horizalign(right)
            self:x((pn == PLAYER_1) and -x + width/2 or x + width/2)
            self:zoom(0.45)
            self:maxwidth(width/0.45)
        end,
        UpdateStepsMessageCommand = function(self, params)
            self:visible(W_PLAYER:IsEnabled(pn))
            if not params.Song then
                self:diffusealpha(0.5)
                self:settext(W_STRING:Number(0))
                return
            end
            if params.Player == pn and params.Steps then
                local profile = PROFILEMAN:GetProfile(pn)
                local highscores = profile and profile:GetHighScoreList(params.Song, params.Steps):GetHighScores() or nil
                local score = (#highscores > 0) and highscores[1]:GetScore() or 0
                if score <= 0 then
                    self:diffusealpha(0.5)
                    self:settext(W_STRING:Number(0))
                else
                    self:diffusealpha(1)
                    self:settext(W_STRING:Number(score))
                end
            end
        end,
    }
end

return Def.ActorFrame({
    Def.Quad({
        InitCommand = function(self)
            self:zoomto(x*2 + width*2, 15)
            self:diffuse(1, 1, 1, 0.75)
            self:fadeleft(0.8)
            self:faderight(0.8)
        end,
    }),
    LoadFont('Common Small Bold')..{
        Text = 'HIGHSCORE',
        InitCommand = function(self)
            self:diffuse(Color('White'))
            self:zoom(0.4)
        end,
    },
    PlayerScoreActor(PLAYER_1),
    PlayerScoreActor(PLAYER_2),
})