local player = ...
local categories = {
    {Category = 'RadarCategory_TapsAndHolds', Label = 'TAPs'},
    {Category = 'RadarCategory_Jumps', Label = 'JUMPs'},
    {Category = 'RadarCategory_Holds', Label = 'HOLDs'},
    {Category = 'RadarCategory_Mines', Label = 'MINEs'},
    {Category = 'RadarCategory_Hands', Label = 'HANDs'},
    {Category = 'RadarCategory_Rolls', Label = 'ROLLs'},
    {Category = 'RadarCategory_Lifts', Label = 'LIFTs'},
    {Category = 'RadarCategory_Fakes', Label = 'FAKEs'},
}
local width  = 50
local height = 12

local actors = Def.ActorFrame({
    InitCommand=function(self)
        self:visible(W_PLAYER:IsEnabled(player))
    end,
    UpdateStepsMessageCommand = function(self, params)
        self:visible(W_PLAYER:IsEnabled(player))
    end,
    Def.ActorFrame({
        InitCommand = function(self)
            self:y(60)
        end,
        -- Def.Quad({
        --     InitCommand = function(self)
        --         self:zoomto(60, 96)
        --         self:diffuse(0, 0, 0, 0.25)
        --     end,
        -- }),
        LoadActor(W:Object('boxshadow'), 'steps', {
            Length = 6,
            Color  = {0, 0, 0, 0.25},
            Center = {0.1, 0.1, 0.1, 0.25},
        })..{
            OnCommand = function(self)
                self:playcommand('UpdateBoxShadow', {
                    Id         = 'steps',
                    Width      = 60,
                    Height     = 96,
                })
            end,
        },
        Def.Quad({
            InitCommand = function(self)
                self:zoomto(60, 96)
                -- self:y(-48+60)
                -- self:zoomto(60, 1)
                self:blend('BlendMode_Add')
                self:diffuse(W_PLAYER:Color(player))
                self:diffusealpha(0.1)
                self:faderight((player == PLAYER_1) and 1 or 0.1)
                self:fadeleft((player == PLAYER_1) and 0.1 or 1)
            end,
        }),
    }),
})

for i=1, #categories do
    -- ラベル
    actors[#actors+1] = LoadFont('Common Small Normal')..{
        Text = categories[i].Label,
        InitCommand = function(self)
            self:diffuse(0.8, 0.8, 0.8, 1.0)
            self:diffusealpha(0.8)
            self:vertalign(top)
            self:horizalign(left)
            self:x(-width/2)
            self:y(i*height + 4)
            self:zoom(0.3)
            self:maxwidth((width*0.45)/0.3)
        end,
    }
    -- 値（デフォルト3桁表示、0の時は半透明）
    actors[#actors+1] = LoadFont('Common Small Bold')..{
        InitCommand = function(self)
            self:diffuse(0.8, 0.8, 0.8, 1.0)
            self:vertalign(bottom)
            self:horizalign(right)
            self:x(width/2)
            self:y(i*height + height-4)
            self:zoom(0.42)
            self:maxwidth((width*0.55)/0.42)
        end,
        UpdateStepsMessageCommand = function(self, params)
            if not params.Song then
                self:diffusealpha(0.5)
                self:settext('0')
                return
            end
            if params.Player == player and params.Steps then
                local value = params.Steps:GetRadarValues(params.Player):GetValue(categories[i].Category)
                self:diffusealpha((value and value > 0 ) and 1 or 0.5)
                self:settextf('%d', value or 0)
            end
        end,
    }
end

return actors