local t = Def.ActorFrame({
    FOV=90,
    OnCommand = function(self)
        self:Center()
    end,
    PlayerJoinedMessageCommand = function(self, params)
        -- ゲストユーザーの場合オプションリセット
        if W_PLAYER:ProfileType(params.Player) == 'ProfileType_Guest' then
            W_OPTION:ResetGuest(params.Player)
        end
    end,
    OffCommand = function(self)
        W_NET:Save()
    end,
    CancelCommand = function(self)
        W_NET:Save()
    end,
})

-- 背景
t[#t+1] = LoadActor('_parts/bg')
-- ステージ
t[#t+1] = LoadActor('_parts/stage')

if GAMESTATE:IsCourseMode() then
    -- コース情報
    t[#t+1] = LoadActor('_parts/course')
else
    -- 曲情報
    t[#t+1] = LoadActor('_parts/song')
end

-- ホイール
t[#t+1] = LoadActor('_parts/wheel')

if not GAMESTATE:IsCourseMode() then
    -- グループ情報
    t[#t+1] = LoadActor('_parts/group')
    -- 譜面情報
    t[#t+1] = LoadActor('_parts/steps')
end
-- ハイスピード情報
t[#t+1] = LoadActor(W:Object('highspeed label'), 'SelectMusic')..{
    OnCommand = function(self)
        self:xy(-SCREEN_CENTER_X, -SCREEN_CENTER_Y)
        self:playcommand('Show')
    end,
    OffCommand = function(self)
        self:playcommand('Hide', {Sleep = 0.2, Wait = 0.3})
    end,
    PlayerJoinedMessageCommand = function(self, params)
        self:playcommand('ShowSelectMusicNewPlayer', {Player = params.Player})
    end,
}
if not GAMESTATE:IsCourseMode() then
    -- レーダー
    t[#t+1] = LoadActor('_parts/radar')
end

-- 開始前に表示するターゲットスコア
t[#t+1] = LoadActor(W:Object('target/static'), 'SelectMusic')..{
    InitCommand = function(self)
        self:xy(-SCREEN_CENTER_X, -SCREEN_CENTER_Y)
    end,
}

t[#t+1] = Def.HelpDisplay({
    File = 'Common Small Normal',
    InitCommand=function(self)
        self:diffuse(Color('White'))
        self:zoom(0.4);
        self:xy(0, SCREEN_CENTER_Y-12)
        self:SetSecsBetweenSwitches(3.0)
        self:SetTipsColonSeparated(THEME:GetString('ScreenSelectMusic', 'HelperText'..(GAMESTATE:IsEventMode() and 'Event' or 'Arcade')))
    end,
    OffCommand = function(self)
        self:sleep(0.2)
        self:linear(0.3)
        self:addy(30)
    end,
})

t[#t+1] = LoadFont('Common Normal')..{
    Text = 'いやんえっちーみないでよ～＞＜',
    InitCommand = function(self)
        self:strokecolor(Color('Outline'))
        self:y(-(SCREEN_CENTER_Y + 50))
    end
}
t[#t+1] = LoadFont('Common Normal')..{
    Text = '背景のぼけた画像はお出かけした時に撮った写真です',
    InitCommand = function(self)
        self:strokecolor(Color('Outline'))
        self:y(SCREEN_CENTER_Y + 50)
    end
}

return t