local menuW, menuH = 220, 200*0.8

return Def.ActorFrame({
    OnCommand = function(self)
        self:xy(-SCREEN_CENTER_X, -SCREEN_CENTER_Y)
    end,
    Def.ActorFrame({
        OnCommand = function(self)
            self:xy(55, SCREEN_BOTTOM - 60)
            self:addy(200)
            self:bounceend(0.4)
            self:addy(-200)
        end,
        LoadActor(W:Object('boxshadow'), 'clock', {
            Length = 20,
            Color  = color('0.1, 0.1, 0.1, 0.5'),
            Center = color('0, 0, 0, 0'),
        })..{
            InitCommand = function(self)
                self:playcommand('UpdateBoxShadow', {
                    Id     = 'clock',
                    Width  = 90,
                    Height = 100,
                })
            end,
        },
        LoadActor(W:Object('clock'), color('0.25, 0.45, 0.55, 0.65')),
    }),
    LoadActor(W:Object('logo'))..{
        OnCommand = function(self)
            if IsHome() then
                self:x(THEME:GetMetric('ScreenTitleMenu', 'LogoX'))
                self:y(THEME:GetMetric('ScreenTitleMenu', 'LogoY'))
            else
                self:zoom(1.5)
                self:xy(SCREEN_CENTER_X, SCREEN_CENTER_Y - 50)
            end
        end,
    },
    Def.ActorFrame({
        OnCommand = function(self)
            self:visible(IsHome())
            self:xy(THEME:GetMetric('ScreenTitleMenu', 'ScrollerX'), THEME:GetMetric('ScreenTitleMenu', 'ScrollerY'))
            self:zoomx(0)
            self:sleep(0.3)
            self:bounceend(0.2)
            self:zoomx(1)
        end,
        LoadActor(W:Object('boxshadow'), 'Bg', {
            Width  = menuW,
            Height = menuH,
            Center = color('#10101099'),
            Color  = color('#00000080'),
            Length = 30,
        })..{
            OnCommand = function(self)
                if IsHome() then
                    self:playcommand('UpdateBoxShadow', {
                        Id     = 'Bg',
                        Width  = menuW,
                        Height = menuH,
                    })
                end
            end,
        },
        LoadActor(W:Object('boxline'), 'Border', {
            Width  = menuW,
            Height = menuH,
            Border = 0.75,
            Color  = color('1, 1, 1, 0.25'),
        }),
        -- Def.Quad({
        --     OnCommand = function(self)
        --         self:x(85-1)
        --         self:zoomto(2, 200)
        --         self:diffuse(1, 1, 1, 0.75)
        --         --self:faderight(1)
        --     end,
        -- }),
    }),
    LoadFont('Common Normal')..{
        Text = '&START;'..THEME:GetString('ScreenTitleMenu', 'Game Start'),
        OnCommand = function(self)
            self:xy(SCREEN_CENTER_X, SCREEN_CENTER_Y + 100)
            self:diffuse(1, 1, 1, 1)
            self:strokecolor(0, 0, 0, 1)
            self:diffuseshift()
            self:effectcolor1(1, 1, 1, 1)
            self:effectcolor2(0.5, 0.5, 0.5, 1)
            self:effectperiod(0.25)
            self:playcommand('CoinsChanged')
        end,
        CoinsChangedMessageCommand = function(self)
            self:visible(not IsHome() and (GAMESTATE:GetCoins() >= GAMESTATE:GetCoinsNeededToJoin()))
        end,
    },
})
