local function InfoActor(label, value, icon, ...)
    local warning = ...
    local c = warning and {1.0, 1.0, 0.5} or {1.0, 1.0, 1.0}
    return Def.ActorFrame({
        LoadActor(icon and THEME:GetPathG('', 'ScreenTitleMenu/_parts/icon/'..icon) or THEME:GetPathG('', '_blank'))..{
            OnCommand = function(self)
                self:vertalign(middle)
                self:horizalign(right)
                self:zoom(0.5)
                self:xy(44, 10)
                self:diffuse(1.0, 1.0, 1.0, 0.8)
                if icon then
                else
                    self:visible(false)
                end
            end,
        },
        LoadFont('Common Small Normal')..{
            Text = label,
            OnCommand = function(self)
                self:vertalign(top)
                self:horizalign(left)
                self:zoom(0.4)
                self:x(50)
                self:diffuse(c[1], c[2], c[3], 0.8)
                self:maxwidth(140/0.4)
            end,
        },
        LoadFont('Common Small Normal')..{
            Text = value,
            OnCommand = function(self)
                self:vertalign(bottom)
                self:horizalign(left)
                self:zoom(0.6)
                self:xy(50, 18)
                self:diffuse(c[1], c[2], c[3], 1.0)
                self:maxwidth(140/0.6)
            end,
        },
    })
end

local function VerActor(label, value, subValue, icon, ...)
    local warning = ...
    local c = warning and {1.0, 1.0, 0.5} or {1.0, 1.0, 1.0}
    return Def.ActorFrame({
        InfoActor(label, value, icon, warning),
        LoadFont('Common Small Normal')..{
            Text = subValue,
            OnCommand = function(self)
                self:vertalign(bottom)
                self:horizalign(left)
                self:zoom(0.4)
                self:xy(90, 27)
                self:diffuse(c[1], c[2], c[3], 0.8)
                self:maxwidth(140/0.4)
            end,
        },
    })
end

local function LineActor(y)
    return Def.Quad({
        OnCommand = function(self)
            self:y(y)
            self:horizalign(left)
            self:zoomto(200, 1)
            self:diffuse(1.0, 1.0, 1.0, 0.5)
            self:fadeleft(1.0)
        end,
    })
end

local function OnAnimation(self, index)
    self:diffusealpha(0)
    self:addx(-100)
    self:sleep(index*0.05)
    self:decelerate(0.2)
    self:addx(100)
    self:diffusealpha(1)
end

return Def.ActorFrame({
    VerActor(ProductFamily(), ProductVersion(), VersionDate(), 'stepmania'
        , --[[YA_VER:Version() > 5100
            or YA_VER:Version() < 120--]]
            -- 5.0.12 - 5.1NB 20200616 （以降は背景動画がズレる不具合がある）
            tonumber(VersionDate()) < 20160811
            or tonumber(VersionDate()) > 20200614)..{
        OnCommand = function(self)
            self:y(15)
            OnAnimation(self, 0)
        end,
    },
    VerActor(W:Name(), W:Ver('main'), W:Ver('sub'), 'waiei', W:Ver('sub') ~= '')..{
        OnCommand = function(self)
            self:y(50)
            OnAnimation(self, 1)
        end,
    },
    LineActor(85),
    InfoActor('Life Difficulty', GetLifeDifficulty(), 'life'
        , GetLifeDifficulty() ~= 4)..{
        OnCommand = function(self)
            self:y(100)
            OnAnimation(self, 2)
        end,
    },
    InfoActor('Timing Difficulty', GetTimingDifficulty(), 'timing'
        , GetTimingDifficulty() ~= 4)..{
        OnCommand = function(self)
            self:y(135)
            OnAnimation(self, 3)
        end,
    },
    LineActor(170),
    InfoActor('Songs', SONGMAN:GetNumSongs(), 'song', SONGMAN:GetNumSongs() <= 0)..{
        OnCommand = function(self)
            self:y(185)
            OnAnimation(self, 4)
        end,
    },
    InfoActor('Courses', SONGMAN:GetNumCourses(), 'course'
        , SONGMAN:GetNumCourses() <= 0)..{
        OnCommand = function(self)
            self:y(220)
            OnAnimation(self, 5)
        end,
    },
    LineActor(255),
    InfoActor('Game', W_STRING:UpperFirst(GAMESTATE:GetCurrentGame():GetName())
        , 'game', GAMESTATE:GetCurrentGame():GetName() ~= 'dance')..{
        OnCommand = function(self)
            self:y(270)
            OnAnimation(self, 6)
        end,
    },
    InfoActor('Mode', GAMESTATE:IsEventMode() and 'Event' or 'Arcade'
        , 'event', not GAMESTATE:IsEventMode())..{
        OnCommand = function(self)
            self:y(305)
            OnAnimation(self, 7)
        end,
    },
    InfoActor(
        (GetServerName() == '') and 'Server' or GetServerName()
        , W_NET:IsConnected() and 'Connected' or 'Disconnected'
        , 'server'
        , W_NET:IsConnected()
    )..{
        OnCommand = function(self)
            self:y(340)
            OnAnimation(self, 8)
        end,
    },
    LineActor(375),
    LoadActor(W:Object('waiei/core'))..{
        InitCommand = function(self)
            self:x(100)
            self:y(425)
            self:zoom(0.25)
        end
    },
})